<template>
    <vue-good-table :columns="columns" :rows="rows" :search-options="{ enabled: searchOptions }" :fixed-header="fixedHeader"
        :pagination-options="{
            enabled: paginationEnabled,
            mode: 'records',
            perPage: rowsPerPage,
        }" :max-height="maxHeight">
        <template v-slot:table-row="props: any">
            <span v-if=" excludeColumns.includes(props.column.field) ">
                {{ props.formattedRow[props.column.field] }}
            </span>
            <span v-else :class=" formatFunction(props) ">
                {{ props.formattedRow[props.column.field] }}
            </span>
        </template>

    </vue-good-table>
</template>

<script setup lang="ts">
import { ref, watchEffect, onMounted } from 'vue';
import { convertDataToTableData, type ConvertDataToTableDataParams } from '@/textualTablePrep';


type Props = {
    data: any;
    filterData?: any;
    formatFunction?: ((props: any) => {});
    measurements?: any;
    excludeColumns?: any;
    searchOptions?: boolean;
    maxHeight?: string;
    rowsPerPage?: number;
    fixedHeader?: boolean;
    paginationEnabled?: boolean;
    hideColumns?: any;
    columnOrder?: any;
    rowOrder?: any;
    rowOrderDirection?: string


}

const props = withDefaults(defineProps<Props>(), {
    searchOptions: true,
    maxHeight: '400px',
    rowsPerPage: 100,
    fixedHeader: true,
    paginationEnabled: true,
    excludeColumns: [],
    hideColumns: [] as Array<string>,
    rowOrderDirection: 'asc',
    formatFunction: (props: any) => {
        return 'cell-na';
    }
});


const columns: any = ref([]);
const rows = ref([]);
const isMounted = ref(false);

const createTableData = (() => {
    const data = props.data.filter((row: any) => {
        if (props.filterData) {
            return props.filterData.includes(row.country_name);
        } else {
            return true;
        }
    });

    const args: ConvertDataToTableDataParams = {
        data: data,
        measurements: props.measurements,
        hideColumns: props.hideColumns,
        columnOrder: props.columnOrder,
        rowOrder: props.rowOrder,
        rowOrderDirection: props.rowOrderDirection
    };


    const results = convertDataToTableData(args);
    rows.value = results.rows;
    columns.value = results.columns;


});

watchEffect(() => {
    if (isMounted.value) { createTableData(); }
});

onMounted(() => {
    createTableData();
    isMounted.value = true;
});

</script>

<style scoped lang="scss">
@import '@/scss/chart.scss';
</style>